
`timescale 1ps / 1ps

module baseball (clk, reset_n, key, seg_out, seg_sel);

  input clk;
  input reset_n;
  input [9:0] key;
  output [6:0] seg_out;
  output [7:0] seg_sel;

  wire clk;
  wire reset_n;
  wire [9:0] key;
  wire [6:0] seg_out;
  wire [7:0] seg_sel;

  wire [3:0] key_hex;

  wire [3:0] seg_a;
  wire [3:0] seg_b;
  wire [3:0] seg_c;
  wire [3:0] seg_d;
  wire [3:0] seg_e;
  wire [3:0] seg_f;
  wire [3:0] seg_g;
  wire [3:0] seg_h;

  wire stb_in;

  wire [3:0] key_a;
  wire [3:0] key_b;
  wire [3:0] key_c;
  wire [3:0] key_d;

  wire [3:0] hrkey_a;
  wire [3:0] hrkey_b;
  wire [3:0] hrkey_c;
  wire [3:0] hrkey_d;

  wire key_comp;

  key_encoder key_encoder1 (key, key_hex);
  key_detector key_detector1 (clk, key, stb_in);
  key_reg key_reg1 (clk, reset_n, stb_in, key_hex, key_a, key_b, key_c, key_d,
    key_comp);
  hr_reg hr_reg1 (hrkey_a, hrkey_b, hrkey_c, hrkey_d);
  main main1 (key_comp, key_a, key_b, key_c, key_d, hrkey_a, hrkey_b, hrkey_c,
    hrkey_d, seg_a, seg_b, seg_c, seg_d, seg_e, seg_f, seg_g, seg_h);
  seg_driver seg_driver1 (clk, seg_a, seg_b, seg_c, seg_d, seg_e, seg_f, seg_g,
    seg_h, seg_out, seg_sel);

endmodule
