`timescale 1ps / 1ps

module key_encoder (key_in, key_out);
  input [9:0] key_in;
  output [3:0] key_out;

  wire [9:0] key_in;
  wire [3:0] key_out;

  function [3:0] key_encoder_impl;
    input [9:0] key_in2;
    casex (key_in2)

      10'bxxxxxxxxx1: begin
        key_encoder_impl = 0;
      end

      10'bxxxxxxxx10: begin
        key_encoder_impl = 1;
      end

      10'bxxxxxxx100: begin
        key_encoder_impl = 2;
      end

      10'bxxxxxx1000: begin
        key_encoder_impl = 3;
      end

      10'bxxxxx10000: begin
        key_encoder_impl = 4;
      end

      10'bxxxx100000: begin
        key_encoder_impl = 5;
      end

      10'bxxx1000000: begin
        key_encoder_impl = 6;
      end

      10'bxx10000000: begin
        key_encoder_impl = 7;
      end

      10'bx100000000: begin
        key_encoder_impl = 8;
      end

      10'b1000000000: begin
        key_encoder_impl = 9;
      end

      default: begin
      end

    endcase
  endfunction

  assign key_out = key_encoder_impl (key_in);

endmodule
