
`timescale 1ps / 1ps

module mux_8to1 (mux_in, mux_sel, mux_out);
  input [7:0] mux_in;
  input [2:0] mux_sel;
  output mux_out;

  wire [7:0] mux_in;
  wire [2:0] mux_sel;
  wire mux_out;
  
  function mux_8to1_impl;
    input [7:0] mux_in2;
    input [2:0] mux_sel2;

    case (mux_sel2)

      // 0
      3'b000: begin
        mux_8to1_impl = mux_in2[7];
      end

      // 1
      3'b001: begin
        mux_8to1_impl = mux_in2[6];
      end

      // 2
      3'b010: begin
        mux_8to1_impl = mux_in2[5];
      end

      // 3
      3'b011: begin
        mux_8to1_impl = mux_in2[4];
      end

      // 4
      3'b100: begin
        mux_8to1_impl = mux_in2[3];
      end

      // 5
      3'b101: begin
        mux_8to1_impl = mux_in2[2];
      end

      // 6
      3'b110: begin
        mux_8to1_impl = mux_in2[1];
      end

      // 7
      3'b111: begin
        mux_8to1_impl = mux_in2[0];
      end

      default: begin
      end

    endcase

  endfunction

  assign mux_out = mux_8to1_impl (mux_in, mux_sel);

endmodule
